/** include file of gpsutil.c
  @file
  @author C. Claveleira
  @date 1999-2004
*/
/*
   Copyright (C) 1999-2004 Christian Claveleira (Christian.Claveleira@cru.fr)

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/* 	$Id: gpsutil.h,v 1.9 2004/11/17 21:13:54 clavelei Exp $	 */

//struct TrkDB
//{                                    /* nouvelle structure header base de donnees de trackpoints */
//  Object obj; /* objet contenant le header */
    /* D300_Trk_Point_Type tracks[]; // suivent les trackpoints (en format "host") */
//};


//#define TrkptsInTrkDB(rech) ((MemHandleSize (rech) - sizeof (Custom_Trk_Hdr_Type)-sizeof(((Object *)0)->header)) / sizeof (Custom_Trk_Point_Type))    /* nombre de trackpoints dans une trace */

//struct RteDB
//{                                    /*  structure base de donnees de routes */
//    D201_Rte_Hdr_Type h;             /* header (verifier alignements) */
    /*Raw_D103_Wpt_Type w[];      suivent les waypoints (en format "network") */
//};

// #define WptsInRteDB(rech) (((unsigned int)(MemHandleSize (rech) - sizeof (struct RteDB))) / sizeof (Raw_D103_Wpt_Type))      /* nombre de wpts dans une route */


#define PI  3.14159265358979323846
static const UInt32 OnePower31 = (1UL << 31);	/* 1**31 */
static const UInt32 OnePower31Pi = (1UL << 31) / PI;	/* 1**31/PI */

/* Debugging : */
#define GPSUDBG_INFOS 128				   // informational
#define GPSUDBG_CALLS 32				   // procedures calls/exits
#define GPSUDBG_UNEXP 8					   // unexpected things

#define BadCoordinate -1000.				   /* returned if error in coordinates conversion */
#define OBJECTVERSION 2					   /* object format version */

// #define offsetof(s,m) ((UInt)&(((s *)0)->m))
#define NextObject(o) ( (char *)o + SizeOfObject(o) )

#ifndef GPSLDBG_INFOS // si gpslib pas deja inclus
typedef void LogProc (char *p);
typedef LogProc *LogProcPtr;
#endif

// object.c :
extern UInt16 SizeOfObject (Object * p) UTIL_SECTION;
extern UInt16 ObjectsInRec (MemHandle RecH) UTIL_SECTION;
extern UInt16 OffsetOfObjectInRec (MemHandle RecH, UInt16 n) UTIL_SECTION;
extern UInt16 G100ToCustom (Raw_D100_Wpt_Type * p100, Custom_Wpt_Type * pcust) UTIL_SECTION;
extern UInt16 G102ToCustom (Raw_D102_Wpt_Type * p102, Custom_Wpt_Type * pcust) UTIL_SECTION;
extern UInt16 G103ToCustom (Raw_D103_Wpt_Type * p103, Custom_Wpt_Type * pcust) UTIL_SECTION;
extern UInt16 G104ToCustom (Raw_D104_Wpt_Type * p104, Custom_Wpt_Type * pcust) UTIL_SECTION;
extern UInt16 G105ToCustom (Raw_D105_Wpt_Type * p105, Custom_Wpt_Type * pcust) UTIL_SECTION;
extern UInt16 G107ToCustom (Raw_D107_Wpt_Type * p107, Custom_Wpt_Type * pcust) UTIL_SECTION;
extern UInt16 G108ToCustom (Raw_D108_Wpt_Type * p108, Custom_Wpt_Type * pcust) UTIL_SECTION;
extern UInt16 G109ToCustom (Raw_D109_Wpt_Type * p109, Custom_Wpt_Type * pcust) UTIL_SECTION;
extern UInt16 CustomToG100 (Custom_Wpt_Type * pcust, Raw_D100_Wpt_Type * p100) UTIL_SECTION;
extern UInt16 CustomToG102 (Custom_Wpt_Type * pcust, Raw_D102_Wpt_Type * p102) UTIL_SECTION;
extern UInt16 CustomToG103 (Custom_Wpt_Type * pcust, Raw_D103_Wpt_Type * p103) UTIL_SECTION;
extern UInt16 CustomToG104 (Custom_Wpt_Type * pcust, Raw_D104_Wpt_Type * p104) UTIL_SECTION;
extern UInt16 CustomToG105 (Custom_Wpt_Type * pcust, Raw_D105_Wpt_Type * p105) UTIL_SECTION;
extern UInt16 CustomToG107 (Custom_Wpt_Type * pcust, Raw_D107_Wpt_Type * p107) UTIL_SECTION;
extern UInt16 CustomToB108 (Custom_Wpt_Type * pcust, B108_Wpt_Type * p108, Boolean merge) UTIL_SECTION;
extern UInt16 CustomToB109 (Custom_Wpt_Type * pcust, B109_Wpt_Type * p109, Boolean merge) UTIL_SECTION;
extern LocalFormatID PtrToCustomWpt (Object * recp, Custom_Wpt_Type * pcust) UTIL_SECTION;
extern LocalFormatID HandleToCustomWpt (ObjectHandle RecH, Custom_Wpt_Type * pcust) UTIL_SECTION;
extern LocalFormatID IndexToCustomWpt (UInt16 index, DmOpenRef DB, Custom_Wpt_Type * pcust) UTIL_SECTION;
extern Err CustomToAnyWpt (Custom_Wpt_Type * pcust, LocalFormatID format, ObjectPtr newp,
			   Boolean merge) UTIL_SECTION;
extern Object *AnyToAnyWpt (Object * from, Object * to, LocalFormatID toformat) UTIL_SECTION;
extern UInt16 WptsInRteDB (MemHandle RecH) UTIL_SECTION;
extern LocalFormatID PtrToCustomRteHdr (Object * recp, Custom_Rte_Hdr_Type * pcust) UTIL_SECTION;
extern LocalFormatID HandleToCustomRteHdr (MemHandle RecH, Custom_Rte_Hdr_Type * pcust) UTIL_SECTION;
extern Object *CustomToRteHdrObj (Custom_Rte_Hdr_Type * pcust, Object * o, LocalFormatID toformat) UTIL_SECTION;
extern Object *AnyToAnyRteHdr (Object * from, Object * to, LocalFormatID toformat) UTIL_SECTION;
extern UInt16 TrkptsInTrkDB (MemHandle rech) UTIL_SECTION;
/*  extern void RawD301ToCustomTrkPt (Raw_D301_Trk_Point_Type * from, Custom_Trk_Point_Type * to); */
/*  extern void RawD301ToCompactTrkPt (Raw_D301_Trk_Point_Type * from, Compact_Trk_Point_Type * to); */
/*  extern void RawD300ToCustomTrkPt (Raw_D300_Trk_Point_Type * from, Custom_Trk_Point_Type * to); */
/*  extern void RawD300ToCompactTrkPt (Raw_D300_Trk_Point_Type * from, Compact_Trk_Point_Type * to); */
extern void CustomToRawD301TrkPt (Custom_Trk_Point_Type * from, Raw_D301_Trk_Point_Type * to) UTIL_SECTION;
extern void CompactToRawD301TrkPt (Compact_Trk_Point_Type * from, Raw_D301_Trk_Point_Type * to) UTIL_SECTION;
extern void CustomToRawD300TrkPt (Custom_Trk_Point_Type * from, Raw_D300_Trk_Point_Type * to) UTIL_SECTION;
extern void CompactToRawD300TrkPt (Compact_Trk_Point_Type * from, Raw_D300_Trk_Point_Type * to) UTIL_SECTION;
extern UInt16 AnyRawToAnyTrkPt (LocalFormatID in_format, LocalFormatID out_format,
			      GarminObject * from, TrkPts * to) UTIL_SECTION;
extern void CustomTrkHdrToD310 (Object * trkhdr, D310_Trk_Hdr_Type * d310) UTIL_SECTION;
extern Symbol_Type smblToSymbolType (byte smbl) UTIL_SECTION;
extern byte SymbolTypeTosmbl (Symbol_Type smbl) UTIL_SECTION;
extern UInt16 symb_gid2lid (Symbol_Type gid) UTIL_SECTION;
extern Symbol_Type symb_lid2gid (UInt16 lid) UTIL_SECTION;


// gpsutil.c :

extern void *GetObjPtr (UInt16 objindex) UTIL_SECTION;
extern void HideObject (UInt16 objID) UTIL_SECTION;
extern void ShowObject (UInt16 objID) UTIL_SECTION;
extern Int16 RecIdToPosition (DmOpenRef DB, UInt16 category, UInt32 recid, UInt16 * indexp) UTIL_SECTION;
extern UInt32 GetRecordID (DmOpenRef DB, UInt16 index) UTIL_SECTION;
extern char *DegreToDM (double coord, Boolean longitude, Boolean nmea) UTIL_SECTION;
extern char *DegreToDMS (double coord, Boolean longitude) UTIL_SECTION;
extern char *DegreToD (double coord, Boolean longitude) UTIL_SECTION;
extern char *DegreToChars (double coord, Boolean longitude, DisplayFormat DispMode) UTIL_SECTION;
extern double ReadCoord (char *string, Boolean * longitude) UTIL_SECTION;
extern void SemiToDegre (Semicircle_Type * p, double *latitude, double *longitude) UTIL_SECTION;
extern void DegreToSemi (double latitude, double longitude, Semicircle_Type * p) UTIL_SECTION;
extern void DistBearToSemi (double dist, UInt16 bearing, Semicircle_Type * p) UTIL_SECTION;
extern char *StrNCopySafe (char *dstp, char *srcp, UInt16 dstsize) UTIL_SECTION;
extern void StrNCatSafe (char *dstp, char *srcp, UInt16 dstsize, UInt16 srcsize) UTIL_SECTION;
extern double StrToD (char *p, char **endp) UTIL_SECTION;
extern void StrNToField (char *str, UInt16 length, UInt16 fieldid) UTIL_SECTION;
extern void Canonicalize (char *p, UInt16 l) UTIL_SECTION;
extern double Distance (long lat1, long lon1, long lat2, long lon2, DistanceUnit unit) UTIL_SECTION;
extern double PDistance (long lat1, long lon1, long lat2, long lon2) UTIL_SECTION;
extern UInt16 Bearing (long slat1, long slon1, long slat2, long slon2) UTIL_SECTION;
extern char *DToA (double x, UInt16 digits, UInt16 precision) UTIL_SECTION;
extern void DrawCharsInWidth (char *string, Int16 x, Int16 y, UInt16 w, Boolean RightAligned) UTIL_SECTION;
//extern LocalFormatID DbToCustomWpt (MemHandle RecH, Custom_Wpt_Type * pcust);
extern Int16 DistComp (long lat1, long lon1, long lat2, long lon2, long reflat, long reflon) UTIL_SECTION;
extern void SetMathLibRef (UInt16 ref) UTIL_SECTION;
extern void GpsutilSetDebugLevel (UInt16 debuglevel, LogProcPtr logprocp) UTIL_SECTION;
extern Boolean WptHit (Custom_Wpt_Type * wptp, Semicircle_Type * position) UTIL_SECTION;
extern void SetControlValue (UInt16 objID, short value) UTIL_SECTION;
extern short GetControlValue (UInt16 objID) UTIL_SECTION;
extern void GetObjectBounds (UInt16 objID, RectanglePtr rp) UTIL_SECTION;
