/** Include file of latlong.c
  @file
  @author C. Claveleira
  @date 1999-2004
*/
/*      $Id: latlong.h,v 1.8 2004/11/17 20:49:00 clavelei Exp $     */

struct DATUM
{
    char *name;
    short ellipsoid;
    short dx;
    short dy;
    short dz;
};

struct ELLIPSOID
{
    char *name;			       /* name of ellipsoid */
    double a;			       /* semi-major axis, meters */
    double invf;		       /* 1/f */
};


#define  nDatums 107					   /* nombre de datums definies dans datum.c */
#define WGS84Index 105					   /* index de WGS84 dans datum.c */

extern struct DATUM const gDatum[];
extern struct ELLIPSOID const gEllipsoid[];

#define FromWGS84 1
#define ToWGS84 0

#include "sections.h"
void translate (short fromWGS84, double *latitude, double *longitude, short datumID) LL_SECTION;
