/** include file of log.c 
  @file
  @author C. Claveleira
  @date 1999-2004
 debugging macros
*/

/* debugging mask : 
 128 : informational
  64 :
  32 : procedures calls and exits
  16 : frames
   8 : unexpected things
   4 :
   2 : 
*/

/*  extern  int DebugLevel */
extern int DebugLevel;

extern int DebugIndentLevel;

#ifdef DEBUG
extern char *EvtNames[];
#define LASTVALIDEVTNAME 35				   /* last event name number in EvtNames */

#define debug_open() log_open ()
#define debug_close() log_close ()
#define debug(mask, args) {if ((DebugLevel)&(mask)) log_printf args;}
#define debug_in(mask, args) {if ((DebugLevel)&(mask)) log_printf args;DebugIndentLevel+=2;}
#define debug_enter_func(mask, ...) {if ((DebugLevel)&(mask)) log_printf ("-> "__FUNCTION__ __VA_ARGS__);DebugIndentLevel+=2;}
#define debug_out(mask, args) {DebugIndentLevel-=2;if ((DebugLevel)&(mask)) log_printf args;}
#define debug_exit_func(mask, ...) {DebugIndentLevel-=2;if ((DebugLevel)&(mask)) log_printf ("<- "__FUNCTION__ __VA_ARGS__);}
#else
#define debug_open()
#define debug_close()
#define debug(mask, args)
#define debug_in(mask, args)
#define debug_out(mask, args)
#endif

#include "sections.h"
#ifndef LOG_SECTION
#define LOG_SECTION
#endif

/* log.c : */
extern Err log_open (void) LOG_SECTION;
extern void log_close (void) LOG_SECTION;
extern void log_write (char *p) LOG_SECTION;
extern void log_delete (void) LOG_SECTION;
//extern MemHandle log_get_handle (void) LOG_SECTION;
extern void log_printf (Char* formatStr, ...) LOG_SECTION;
