/** Include file of map.c
  @file
  @author C. Claveleira
  @date 1999-2004
*/

/*
   Copyright (C) 1999,2000,2001,2002 Christian Claveleira (Christian.Claveleira@cru.fr)

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

typedef struct
{
    Boolean DrawWpts,
      DrawGrd,
      DrawRtes,
      DrawTrk,
      DrawActTrk;
    UInt AllowedOps;		       /* cf MapOp*  */
}
MapFlagsType;
extern MapFlagsType MapFlags;

extern RectangleType DrawRect;

#define MapOpActiveRte 0x1				   /* display of active route */
#define MapOpMapTrack  0x2				   /* selection of supplementary track to draw */
//#define MapOpSelTrack  0x4  /* display of selected track */
#define MapOpTrack     0x8				   /* real time track */
#define MapOpRteEdit  0x10				   /* route edition */
#define MapOpRteNew   0x20				   /* route creation */
#define MapOpWptDisp  0x40				   /* waypoint display */


extern void DrawTrack (UInt index, Boolean rescale, Boolean Clear) MAP_SECTION;
extern Boolean MapFormHandleEvent (EventPtr e) MAP_SECTION;
extern Boolean DrawRoute (UInt index, Boolean rescale, Semicircle_Type * position) MAP_SECTION;
